#include "scripts/debug.lua"
#include "scripts/utility.lua"
#include "scripts/body_controller.lua"
#include "scripts/training.lua"
#include "scripts/neural_network.lua"
#include "scripts/genetic_algo.lua"
#include "scripts/registry.lua"
#include "scripts/tool.lua"
#include "scripts/umf.lua"
#include "scripts/json.lua"
#include "scripts/ui.lua"

------------------------------------------------
--- AI Trainer
--- By: Geneosis
------------------------------------------------
hintTimer = 6

function init()

    UI_GAME = false
    checkRegInitialized()

    initDebug()

    tool.tool.init()

end


function tick()

    tool.run()
    BodyController.run()

    debugMod()

end


function draw()

    if tool.tool.active() then
        -- Update key hint
        hintTimer = hintTimer - GetTimeStep()
		uiDrawKeyHint()
        uiDrawTrainingInfo()
        uiDrawDebugMessage() 
    else
		hintTimer = 6
	end
    
    uiDrawBodyControllerInfo() 
    uiManageGameOptions()

end

UpdateQuickloadPatch()
