------------------------------------------------------------------------------------------------
-- Please don't judge this code too heavily. It is a bit of a hack job but it works :)
------------------------------------------------------------------------------------------------


function uiDrawOptions()

    local w = UiWidth()
    local h = UiHeight()
    
    contW = w * 0.9
    contH = h * 0.9
    padH = 10
    padW = 10
    padW2 = padW * 2
    padH2 = padH * 2

    font_heading = 64
    font_normal = 28

    -- Base container.
    uiDrawBaseContainer()

    -- Title container.
    title_w = 128
    title_h = 128
    uiDrawTitleContainer()

    -- Options container.
    options_w = contW - (padW * 2)
    options_h = contH - title_h - (padH * 3)
    options_tabs = 4
    options_tabH = 72
    options_tabW = (options_w - padW2)/options_tabs
    options_tabNames = {'Tool', 'Neural Network', 'Training', 'Info'}
    options_tabSelected = options_tabSelected or options_tabNames[1]
    uiDrawOptionsContainer()

end

function uiDrawBaseContainer()
    ui.padding.create(UiWidth() * 0.1/2, UiHeight() * 0.1/2)
    ui.container.create(contW, contH, ui.colors.g1, 1)
end

function uiDrawTitleContainer()

    -- Title container
    ui.padding.create(padW, padH)
    ui.container.create(contW - title_w, title_h, ui.colors.g2, 1)


    -- Text: Title
    do UiPush()

        -- Mod Preview Image
        local imgW = title_w - padW2
        local imgH = title_h - padH2
        ui.padding.create(padW, padH)
        UiColor(1,1,1,1)
        UiRect(imgW, imgH)
        UiImageBox('img/brain.jpg', imgW, imgH, 1,1)

        -- Mod Title
        ui.padding.create(padW + imgW, 0)
        local textHeight = 64
        UiColor(1,1,1, 1)
        UiFont('bold.ttf', textHeight)
        UiAlign('top left')
        UiText('AI Trainer - '..regGetString('savegame.mod.verison'))

        -- Mod Subtitle
        ui.padding.create(0, textHeight + padH/2)
        textHeight = 32
        UiFont('bold.ttf', textHeight)
        UiText('By: Geneosis')


    UiPop() end

    -- Button: Exit
    do UiPush()

        ui.padding.create(padW, 0)
        ui.padding.create(contW - title_w, 0)

        local btnW = 128 - (padW*3)
        local btnH = 128

        UiAlign('left top')

        -- Exit button
        UiColor(1,0,0,1)
        UiRect(btnW, btnH)

        UiButtonImageBox('ui/common/box-outline-6.png', 1,1, 0,0,0, a)
        if UiBlankButton(btnW, btnH) then
            if UI_GAME then
                UI_GAME = false
            elseif UI_OPTIONS then
                Menu()
            end
        end

        -- X text
        UiColor(1,1,1, 1)
        ui.padding.create(btnW/2, btnH/2)
        UiFont('bold.ttf', btnW/1.5)
        UiAlign('middle center')
        UiText('X')


    UiPop() end

    ui.padding.create(0, title_w)

end

function uiDrawOptionsContainer()

    -- Options container
    ui.padding.create(0, padH)
    ui.container.create(options_w, options_h, ui.colors.g2, 1)

    -- Text: Options
    ui.padding.create(padW, padH)
    do UiPush()
        UiColor(1,1,1, 1)
        UiFont('bold.ttf', font_heading)
        UiAlign('top left')
        UiText('Options')
    UiPop() end


    -- Button: Options reset
    do UiPush()
        ui.padding.create(contW - padW * 4, ((font_heading - font_normal * 1.5)/2))
        UiColor(1,1,1, 1)
        UiFont('bold.ttf', font_normal * 1.5)
        UiAlign('top right')

        local resetButton = UiTextButton('Reset Mod')
        if resetButton then
            modReset()
            beep()
        end

    UiPop() end


    -- Options tabs
    ui.padding.create(0, padH2 + font_heading)
    do UiPush()

        ui.tabView.tab.create("Tool")

        ui.padding.create(options_tabW + (padW/(options_tabs-1)), 0)
        ui.tabView.tab.create("Neural Network")

        ui.padding.create(options_tabW + (padW/(options_tabs-1)), 0)
        ui.tabView.tab.create("Training")

        ui.padding.create(options_tabW + (padW/(options_tabs-1)), 0)
        ui.tabView.tab.create("Info")

    UiPop() end


    -- Options tab content container
    local tabContentH = contH - title_h - options_tabH - options_tabH - padH * 6.5
    ui.padding.create(0, options_tabH)
    ui.container.create(contW - padW*4, tabContentH, ui.colors.g3, 1)


    -- Tab content
    ui.padding.create(padW, padH2)
    ui.container.create(contW - padW*6, tabContentH - padH*3, ui.colors.g1, 1)
    ui.padding.create(padW2*2, padH2*2)
    do UiPush()

        if options_tabSelected == 'Tool' then

            options_tabs_render.Tool()

        elseif options_tabSelected == 'Neural Network' then

            options_tabs_render.NeuralNetwork()

        elseif options_tabSelected == 'Training' then

            options_tabs_render.Training()

        elseif options_tabSelected == 'Info' then

            options_tabs_render.Info()

        end

    UiPop() end

end

objectives = {"balance", "follow", "avoid"}

selectionTypes = {"linear", "roulette"}

crossoverTypes = {"slice-1", "slice-2", "random"}

options_tabs_render = {

    Tool = function()

        do UiPush()

            do UiPush()

                ui.checkBox.create('Highlight AI-controlled objects', 'tool.highlightControllers')
                ui.padding.create(0, 64)
                ui.checkBox.create('Show training info text', 'tool.showTrainingInfo')
                ui.padding.create(0, 64)
                UiColor(1,1,1, 1)
                UiFont('bold.ttf', 32)
                UiText('Log:')
                ui.padding.create(0, 50)
                UiFont('regular.ttf', font_normal)
                if lastDebugMessages then
                    for i=1, #lastDebugMessages do
                        UiText(lastDebugMessages[i])
                        ui.padding.create(0, 28)
                    end
                end

            UiPop() end

            do UiPush()

                ui.padding.create(400, 0)

                ui.checkBox.create('Show AI info on hover', 'tool.showAIInfo')
                ui.padding.create(0, 64)
                
                ui.checkBox.create('Show last log message ingame', 'tool.showDebugMessage')
                ui.padding.create(0, 64)

            UiPop() end

            do UiPush()

                ui.padding.create(800, 0)

                ui.checkBox.create('Attached AIs start active', 'tool.createActiveAI')
                ui.padding.create(0, 64)

                ui.checkBox.create('Randomize AIs added during training', 'tool.randomAddDuringTrain')
                ui.padding.create(0, 64)

            UiPop() end

            do UiPush()

                ui.padding.create(1200, 0)

                ui.checkBox.create('Debug Mode', 'tool.debugMode')
                ui.padding.create(0, 64)

            UiPop() end


        UiPop() end

    end,

    NeuralNetwork = function()

        do UiPush()

            UiColor(1,1,1, 1)
            UiFont('bold.ttf', 32)
            local whiteColor = {r=1, g=1, b=1, a=1}

            do UiPush()
                local objectiveBefore = regGetString('neural_network.objective')
                do UiPush()
                    -- Objective description
                    UiFont('regular.ttf', font_normal)
                    UiAlign('left middle')
                    ui.padding.create(400 + padW2, font_normal * 2)
                    if objectiveBefore == "balance" then
                        UiText("(Try to balance on one corner)")
                    elseif objectiveBefore == "follow" then
                        UiText("(Try to follow the player)")
                    elseif objectiveBefore == "avoid" then
                        UiText("(Try to move away from objects)")
                    end
                UiPop() end

                ui.slider.create('Training objective', 'neural_network.objective', '', nil, nil, nil, nil, nil, nil, nil, objectives)
                local objectiveAfter = regGetString('neural_network.objective')
                -- If objective changed, update default neural network
                if objectiveAfter ~= objectiveBefore then
                    local defaultNN = ai.neural_network.GetDefaultNN(objectiveAfter)
                    regSetString('neural_network.default', ai.neural_network.ToJson(defaultNN))
                    if genetic_algo and genetic_algo.getState() ~= "stopped" then
                        dbm("Training stopped: Objective changed")
                        genetic_algo.stop()
                    end
                end
                ui.padding.create(0, 50)

                local loadDefaultButton = ui.button.create('Load Default', whiteColor, whiteColor)
                if loadDefaultButton then
                    regSetString('neural_network.current', regGetString('neural_network.default'))
                end
                ui.padding.create(0, 50)

                ui.lineEdit.create('Current neural network', 'neural_network.current', 1600)
                ui.padding.create(0, 80)

                local currentNN = ai.neural_network.FromJson(regGetString('neural_network.current'))
                if not currentNN then
                    do UiPush()
                        UiColor(1, 0.6, 0.6, 1)
                        UiAlign('left middle')
                        UiText('ERROR: Invalid syntax in current network, see log in "Tool" tab for more details.\n'
                        ..'FIX: Resolve the error or use the "Load Default" button.')
                    UiPop() end
                else
                    local expectedInputs, expectedOutputs = ai.neural_network.GetExpectedInOut(regGetString('neural_network.objective'))
                    local actualInputs, actualOutputs = ai.neural_network.GetInOut(currentNN)
                    if not (actualInputs == expectedInputs and actualOutputs == expectedOutputs) then
                        do UiPush()
                            UiColor(1, 0.6, 0.6, 1)
                            UiAlign('left middle')
                            UiText('ERROR: Current network has '..tostring(actualInputs)..' inputs and '..tostring(actualOutputs)
                                    ..' outputs, but selected objective requires '..tostring(expectedInputs)..' inputs and '..tostring(expectedOutputs)..' outputs.\n'
                                    ..'FIX: Load a copatible network or use the "Load Default" button.')
                        UiPop() end
                    end
                end
                ui.padding.create(0, 50)
                
                ui.slider.create('Rotation acceleration rate of the object controlled', 'neural_network.accelRate', 'Unit/Second', 1, 10, nil, nil, nil, nil, true)
                ui.padding.create(0, 50)

                ui.slider.create('Distance to player when following', 'neural_network.distToPlayer', 'Meters', 0, 100, nil, nil, nil, nil, true)
                ui.padding.create(0, 50)

                ui.slider.create('Scan range when avoiding', 'neural_network.scanRange', 'Meters', 1, 100, nil, nil, nil, nil, true)
                ui.padding.create(0, 50)

            UiPop() end

            do UiPush()

                ui.padding.create(800, 0)

                local nameToLoad = regGetString('neural_network.loadSelected')
                local savedNeuralNetworks = regListKeys('neural_network.saved')
                local hasSavedNetworks = #savedNeuralNetworks > 0
                -- Makes sure table is never empty (slider doesn't like empty tables)
                if not hasSavedNetworks then
                    savedNeuralNetworks = {"none"}
                end
                -- Makes sure currently selected name is always part of the list
                if TableFind(savedNeuralNetworks, nameToLoad) == nil then
                    regSetString('neural_network.loadSelected', savedNeuralNetworks[1])
                end
                ui.slider.create('Saved neural networks', 'neural_network.loadSelected', '', nil, nil, nil, nil, nil, nil, nil, savedNeuralNetworks)
                nameToLoad = regGetString('neural_network.loadSelected')
                ui.padding.create(0, 50)

                do UiPush()

                    local loadButton = ui.button.create('Load', whiteColor, whiteColor, nil, nil, nil, nil, not hasSavedNetworks)
                    if loadButton then
                        regSetString('neural_network.current', regGetString('neural_network.saved.'..nameToLoad))
                    end
                    ui.padding.create(ui.button.lastWidth + padW, 0)

                    local deleteButton = ui.button.create('Delete', whiteColor, whiteColor, nil, nil, nil, nil, not hasSavedNetworks)
                    if deleteButton then
                        regClearKey('neural_network.saved.'..nameToLoad)
                    end
                    ui.padding.create(ui.button.lastWidth + padW, 0)

                    local saveName = regGetString('neural_network.saveName')
                    local saveButton = ui.button.create('Save as', whiteColor, whiteColor, nil, nil, nil, nil, string.len(saveName) == 0)
                    if saveButton then
                        regSetString('neural_network.saved.'..saveName, regGetString('neural_network.current'))
                    end
                    ui.padding.create(ui.button.lastWidth + padW, -20)

                    ui.lineEdit.create('', 'neural_network.saveName', nil, nil, true)

                UiPop() end
                ui.padding.create(0, 200)

                ui.checkBox.create('Deactivate AI if it encountered an error', 'neural_network.inactiveOnError')
                ui.padding.create(0, 64)

                ui.checkBox.create('Deactivate AI if it broke the object it controls', 'neural_network.inactiveOnBreak')
                ui.padding.create(0, 64)

            UiPop() end

        UiPop() end

    end,

    Training = function()

        UiColor(1,1,1, 1)
        UiFont('bold.ttf', 32)

        do UiPush()

            UiAlign('left middle')
            -- Title
            UiText('Genetic Algorithm')
            -- Group box
            do UiPush()
                ui.padding.create(-20, 20)
                local w = 1040
                local h = 530
                local border = 2
                UiAlign('left top')
                UiColor(ui.colors.g3[1],ui.colors.g3[2],ui.colors.g3[3],1)
                UiRect(w, h)
                ui.padding.create((w / 2), (h / 2))
                UiAlign('center middle')
                UiColor(ui.colors.g1[1],ui.colors.g1[2],ui.colors.g1[3],1)
                UiRect(w- (border * 2), h - (border * 2))
            UiPop() end 
            
            ui.padding.create(1050, 0)

            -- Title
            UiText('Gradient Descent')
            -- Group box
            do UiPush()
                ui.padding.create(-20, 20)
                local w = 580
                local h = 530
                local border = 2
                UiAlign('left top')
                UiColor(ui.colors.g3[1],ui.colors.g3[2],ui.colors.g3[3],1)
                UiRect(w, h)
                ui.padding.create((w / 2), (h / 2))
                UiAlign('center middle')
                UiColor(ui.colors.g1[1],ui.colors.g1[2],ui.colors.g1[3],1)
                UiRect(w- (border * 2), h - (border * 2))
            UiPop() end 

        UiPop() end 

        ui.padding.create(0, 64)

        do UiPush()

            ui.slider.create('Generation duration', 'genetic_algo.generationDuration', 'Seconds', 0, 300, nil, nil, nil, nil, true)
            ui.padding.create(0, 50)

            ui.slider.create('Selection keeps only the top X% fitness', 'genetic_algo.keepTopPercent', '%', 0, 100, nil, nil, nil, nil, true)
            ui.padding.create(0, 50)

            ui.slider.create('Selection method', 'genetic_algo.selectionType', '', nil, nil, nil, nil, nil, nil, nil, selectionTypes)
            ui.padding.create(0, 50)

            ui.slider.create('Proportion of population doing crossover', 'genetic_algo.crossoverPercent', '%', 0, 100, nil, nil, nil, nil, true)
            ui.padding.create(0, 50)

            ui.slider.create('Crossover method', 'genetic_algo.crossoverType', '', nil, nil, nil, nil, nil, nil, nil, crossoverTypes)
            ui.padding.create(0, 50)

        UiPop() end


        do UiPush()

            ui.padding.create(550, 0)

            ui.slider.create('Mutation chance', 'genetic_algo.mutationRate', '%', 0, 100, nil, nil, nil, nil, true)
            ui.padding.create(0, 50)

            ui.range_slider.create('Value range for mutation', 'genetic_algo.mutationMin', 'genetic_algo.mutationMax', nil, -100, 100, nil, nil, nil, nil, true)
            ui.padding.create(0, 50)

            ui.checkBox.create('Mutation multiply exising gene value', 'genetic_algo.mutationMultiply')
            ui.padding.create(0, 64)

            local oldUnbreak = regGetBool('genetic_algo.unbreakableTrain')
            ui.checkBox.create('Unbreakable objects during training', 'genetic_algo.unbreakableTrain')
            local newUnbreak = regGetBool('genetic_algo.unbreakableTrain')
            if genetic_algo and oldUnbreak ~= newUnbreak then
                genetic_algo.updateUnbreakableStates()
            end
            
            ui.padding.create(0, 64)

        UiPop() end


        do UiPush()

            ui.padding.create(1050, 0)

            ui.checkBox.create('Also train neural network during each generation',  'genetic_algo.trainDuringGen')
            ui.padding.create(0, 64)

            ui.slider.create('Number of data samples for training', 'training.batch_size', 'Samples', 1, 100, nil, nil, nil, nil, true)
            ui.padding.create(0, 50)

            ui.slider.create('Exploration decrease rate slowness', 'training.epsilonDecrease', '', 1, 64, nil, nil, nil, nil, true)
            ui.padding.create(0, 30)
            UiAlign('left middle')
            UiColor(0.6,0.6,0.6, 1)
            UiText('Higher values = slower decrease rate')
            ui.padding.create(0, 40)

            ui.checkBox.create('Process all samples at once', 'training.batchMode')
            ui.padding.create(0, 64)
            UiAlign('left middle')
            UiColor(0.6,0.6,0.6, 1)
            UiText('CAUTION: Will cause huge lag spikes with many AIs')

        UiPop() end


        

    end,

    Info = function()

        UiColor(1,1,1, 1)
        UiFont('bold.ttf', 32)
        UiAlign('left middle')

        do UiPush()

            UiText('CONTROLS')
            ui.padding.create(0, 50)
            UiFont('regular.ttf', font_normal)
            ui.keyBinding.create('Attach/Detach AI to object', 'key.attach', true)
            ui.padding.create(0, 50)
            ui.keyBinding.create('Copy AI from object', 'key.copy', true)
            ui.padding.create(0, 50)
            ui.keyBinding.create('Activate/Deactivate AI on object', 'key.activate', true)
            ui.padding.create(0, 50)
            ui.keyBinding.create('Apply current AI and objective to all existing AIs', 'key.convert', true)
            ui.padding.create(0, 50)
            ui.keyBinding.create('Start/Stop training', 'key.start', true)
            ui.padding.create(0, 50)
            ui.keyBinding.create('Pause/Resume training', 'key.pause', true)
            ui.padding.create(0, 50)
            ui.keyBinding.create('Remove all AIs', 'key.remove', true)
            ui.padding.create(0, 50)
            ui.keyBinding.create('Options', 'key.options', true)
            ui.padding.create(0, 50)
            UiColor(0.6,0.6,0.6, 1)
            UiText('To bind a mouse button, when the binding is waiting\nfor an input, click with the button you want\nanywhere outside the binding box.')
            -- ui.padding.create(0, 100)
            -- UiText('To clear a binding, when the binding is waiting\nfor an input, left click inside the binding box.')

        UiPop() end

        do UiPush()

            ui.padding.create(700, 0)

            UiFont('bold.ttf', 32)
            UiText('NOTES')
            UiFont('regular.ttf', font_normal)
            ui.padding.create(0, 50)
            UiText('- This mod is my attempt at bringing some machine learning into Teardown,', true)
            UiText('    it is mostly there to demonstrate it is possible,', true)
            UiText('    and to have fun looking at some basic AIs struggling to achieve simple tasks :p', true)
            UiText('', true)
            UiText('- The "AI" used in this mod is a neural network that you can train to perform various tasks', true)
            UiText('    (only one task at a time though)', true)
            UiText('', true)
            UiText('- The training method used is a Genetic Algorithm, which reproduces the rules of', true)
            UiText('    natural selection to find the best specimens in a group', true)
            UiText('', true)
            UiText('- A starting population of 20 should be good (or down to 10 if you get low FPS) then', true)
            UiText('    with the default settings it can take up to 400 generations to start getting good results', true)
            UiText('', true)
            UiText('- You may want to make some free space around the learning objects and make sure', true)
            UiText('    they are not stuck (objects in water will train badly except for balance objective)', true)
            UiText('', true)
            UiText('- You may want to train the objects on flat ground to avoid learning weird behavor', true)
            UiText('    due to the terrain slopes or being stopped by walls (except for avoid objective)', true)
            UiText('', true)

        UiPop() end

    end,

}

--- Draw keys hint
function uiDrawKeyHint()

    UiPush()

        UiTranslate(20, UiHeight() - 250)

        UiAlign("left middle")
        UiFont('regular.ttf', 28)
		local a = hintTimer / 3
        UiTextShadow(0,0,0, a, 0.3, 0.5)
        UiColor(1,1,1, a)
        UiText('['..string.upper(regGetString('key.attach'))..']: Attach/Detach AI to object')
        ui.padding.create(0, 28)
        UiText('['..string.upper(regGetString('key.copy'))..']: Copy AI from object')
        ui.padding.create(0, 28)
        UiText('['..string.upper(regGetString('key.activate'))..']: Activate/Deactivate AI on object')
        ui.padding.create(0, 28)
        UiText('['..string.upper(regGetString('key.convert'))..']: Apply current NN and objective to all existing AIs')
        ui.padding.create(0, 28)
        UiText('['..string.upper(regGetString('key.start'))..']: Start/Stop training')
        ui.padding.create(0, 28)
        UiText('['..string.upper(regGetString('key.pause'))..']: Pause/Resume training')
        ui.padding.create(0, 28)
        UiText('['..string.upper(regGetString('key.remove'))..']: Remove all AIs')
        ui.padding.create(0, 28)
        UiText('['..string.upper(regGetString('key.options'))..']: Options')
        ui.padding.create(0, 28)

    UiPop()

end

--- Draw training info
function uiDrawTrainingInfo()

    if not regGetBool('tool.showTrainingInfo') then
        return
    end

    UiPush()

        UiTranslate(20, 20)

        UiAlign("left middle")
        UiFont('regular.ttf', 28)
        UiTextShadow(0,0,0, 1, 0.3, 0.5)
        UiColor(1,1,1, 1)
        UiText('Training: '..genetic_algo.getState())
        ui.padding.create(0, 28)
        UiText('Objective: '..regGetString('neural_network.objective'))
        ui.padding.create(0, 28)
        UiText('Population: '..#BodyController.getEligiblePopulationIndexes())
        ui.padding.create(0, 28)
        UiText('Generation: '..genetic_algo.getGeneration())
        ui.padding.create(0, 28)
        UiText('Exploration: '..sfn(training.DeepQLearning.GetExplorationRatio() * 100, 1).."%")
        ui.padding.create(0, 28)
        UiText('Best AI fitness: '..sfn(BodyController.bestFitness() * 100, 1).."%")
        ui.padding.create(0, 28)
        UiText('Average AI fitness: '..sfn(BodyController.averageFitness() * 100, 1).."%")
        ui.padding.create(0, 28)

    UiPop()

end

--- Draw last debug message
function uiDrawDebugMessage()

    if not regGetBool('tool.showDebugMessage') or not lastDebugMessages then
        return
    end

    UiPush()
        
        UiTranslate(20, UiHeight() - 20)

        UiAlign("left middle")
        UiFont('regular.ttf', 22)
        local a = lastDebugTimer / 3
        UiTextShadow(0,0,0, a, 0.3, 0.5)
        UiColor(1,1,1, a)
        UiText(lastDebugMessages[#lastDebugMessages])

    UiPop()

end

--- Draw informarion of the body controller
function uiDrawBodyControllerInfo()

    if not regGetBool('tool.showAIInfo') or not tool.tool.aimBody then
        return
    end

    local bodyController = BodyController.instances.getBodyController(tool.tool.aimBody)

    if not bodyController then
        return
    end

    UiPush()
            
        local centerPos = AabbGetBodyCenterPos(tool.tool.aimBody)
        local x, y, distance = UiWorldToPixel(centerPos)
        UiTranslate(x, y)

        UiAlign("center top")
        UiFont('regular.ttf', 28)
        UiTextShadow(0,0,0, 1, 0.3, 0.5)
        UiColor(1,1,1, 1)
        ui.padding.create(0, 28)
        UiText('Id: '..bodyController.id)
        ui.padding.create(0, 28)
        UiText('Objective: '..bodyController.objective)
        ui.padding.create(0, 28)
        UiText('Status: '..ternary(bodyController.active, "active", "inactive"))
        ui.padding.create(0, 28)
        UiText('Step: '..bodyController.trainingStep)
        ui.padding.create(0, 28)
        UiText('Samples: '..BodyController.bufferCount(bodyController.buffer))
        ui.padding.create(0, 28)
        UiText('Fitness: '..sfn(BodyController.fitness(bodyController) * 100, 1).."%")
        ui.padding.create(0, 28)
        if db then
            UiText('Debug: '..ui.debugStr)
            ui.padding.create(0, 28)
        end

    UiPop()

end

--- Manage when to open and close the options menu.
function uiManageGameOptions()

    if tool.tool.active() then

        if InputPressed(regGetString('key.options')) then UI_GAME = not UI_GAME end

        if UI_GAME then
            UiMakeInteractive()
            uiDrawOptions()
        end

    end

end



ui = {}

ui.debugStr = ""

ui.colors = {
    white = Vec(1,1,1),
    g3 = Vec(0.5,0.5,0.5),
    g2 = Vec(0.35,0.35,0.35),
    g1 = Vec(0.2,0.2,0.2),
    black = Vec(0,0,0),
}



ui.container = {}

function ui.container.create(w, h, c, a)
    if not c then c = Vec(0.5,0.5,0.5) end
    UiColor(c[1], c[2], c[3], a or 0.5)
    UiRect(w, h)
end



ui.padding = {}

function ui.padding.create(w, h)
    UiTranslate(w or 10, h or 10)
end

ui.tabView = {}

ui.tabView.tab = {}

function ui.tabView.tab.create(text)

    do UiPush()

        UiAlign('top left')

        ui.container.create(options_tabW - padW, options_tabH, ui.colors.g1, 1)

        if options_tabSelected == text then
            ui.container.create(options_tabW - padW, options_tabH, ui.colors.g3, 1)
        end

        UiButtonImageBox('ui/common/box-outline-6.png', 1,1, 0,0,0, a)
        if UiBlankButton(options_tabW, options_tabH) then
            if options_tabSelected ~= text then
                PlaySound(LoadSound('clickdown.ogg'), GetCameraTransform().pos, 1)
            end
            options_tabSelected = text
        end

        ui.padding.create(options_tabW/2, options_tabH/2)

        UiColor(1,1,1, 1)
        UiFont('bold.ttf', font_normal*1.25)
        UiAlign('center middle')
        UiText(text)

    UiPop() end

end



ui.slider = {}

function ui.slider.create(title, registryPath, valueText, min, max, w, h, fontSize, inline, intSlider, stringChoices)

    local hasTitle = not(title == nil or title == '')
    local strSlider = stringChoices and #stringChoices > 0 
    local intSlider = intSlider or false
    local value = regGet(ternary(intSlider, "int", "float"), registryPath)

    min = min or 0
    max = max or 300
    inline = inline or false

    local strIndex = {}
    if strSlider then
        min = 1
        max = #stringChoices
        for k,v in pairs(stringChoices) do
            strIndex[v]=k
        end
        local strVal = regGetString(registryPath)
        value = strIndex[strVal]
    end

    UiAlign('left middle')

    -- Text header
    UiColor(1,1,1, 1)
    UiFont('regular.ttf', fontSize or font_normal)
    if hasTitle then
        titleW, titleH = UiText(title)
        if inline then
            UiPush()
            ui.padding.create(titleW + padW2, 0)
        else
            ui.padding.create(0, fontSize or font_normal)
        end
    end

    -- Slider BG
    UiColor(0.4,0.4,0.4, 1)
    local slW = w or 400
    if hasTitle and inline then slW = slW - (titleW + padW2) end
    UiRect(slW, h or 10)

    -- Convert to slider scale.
    value = ((value-min) / (max-min)) * slW
    if max == min then
        value = 0
    end

    -- Slider dot
    UiColor(1,1,1, 1)
    UiAlign('center middle')
    value, done = UiSlider("ui/common/dot.png", "x", value, 0, slW)
    local val = (value/slW) * (max-min) + min -- Convert to true scale.
    if intSlider then val = floatToInt(val) end
    if strSlider then val = stringChoices[floatToInt(val)] end
    if done then
        if strSlider then
            regSetString(registryPath, val)
        elseif intSlider then
            regSetInt(registryPath, val)
        else
            regSetFloat(registryPath, val)
        end
    end

    -- Slider value
    do UiPush()
        UiAlign('left middle')
        ui.padding.create(slW + padW2, 0)
        if strSlider then
            UiText(val .. ' ' .. (valueText or ''))
        else
            local decimals = ternary(val < 100, 3, 1)
            if intSlider then decimals = 0 end
            UiText(sfn(val, decimals) .. ' ' .. (valueText or ''))
        end
    UiPop() end

    if hasTitle and inline then UiPop() end

end

ui.range_slider = {}

function ui.range_slider.create(title, registryPathMin, registryPathMax, valueText, min, max, w, h, fontSize, inline, intSlider)

    local minVal = regGet(ternary(intSlider, "int", "float"), registryPathMin)
    local maxVal = regGet(ternary(intSlider, "int", "float"), registryPathMax)
    fontSize = fontSize or font_normal
    h = h or 10
    
    do UiPush()
        ui.slider.create(title, registryPathMin, valueText, min, max, w, h, fontSize, inline, intSlider)
    UiPop() end

    ui.padding.create(0, fontSize + (2 *h))

    do UiPush()
        ui.slider.create('', registryPathMax, valueText, min, max, w, h, fontSize, inline, intSlider)
    UiPop() end

    local newMinVal = regGet(ternary(intSlider, "int", "float"), registryPathMin)
    local newMaxVal = regGet(ternary(intSlider, "int", "float"), registryPathMax)
    if newMinVal ~= minVal then
        if newMaxVal < newMinVal then
            regSet(ternary(intSlider, "int", "float"), registryPathMax, newMinVal)
        end
    elseif newMaxVal ~= maxVal then
        if newMaxVal < newMinVal then
            regSet(ternary(intSlider, "int", "float"), registryPathMin, newMaxVal)
        end
    end

end


ui.checkBox = {}

function ui.checkBox.create(title, registryPath, inline)

    local value = regGetBool(registryPath)

    UiAlign('left middle')

    -- Text header
    UiColor(1,1,1, 1)
    UiFont('regular.ttf', fontSize or font_normal)
    if not inline then
        UiText(title)
        ui.padding.create(0, fontSize or font_normal)
    end

    -- Toggle BG
    UiAlign('left top')
    UiColor(0.4,0.4,0.4, 1)
    local tglW = w or 140
    local tglH = h or 40
    UiRect(tglW, h or tglH)

    -- Render toggle
    do UiPush()

        local toggleText = 'ON'

        if value then
            ui.padding.create(tglW/2, 0)
            UiColor(0,0.8,0, 1)
        else
            toggleText = 'OFF'
            UiColor(0.8,0,0, 1)
        end

        UiRect(tglW/2, tglH)

        do UiPush()
            ui.padding.create(tglW/4, tglH/2)
            UiColor(1,1,1, 1)
            UiFont('bold.ttf', font_normal)
            UiAlign('center middle')
            UiText(toggleText)
        UiPop() end

    UiPop() end

    if inline then
        do UiPush()
            ui.padding.create(tglW + padW2, tglH/2)
            UiAlign('left middle')
            UiColor(1,1,1, 1)
            UiFont('regular.ttf', fontSize or font_normal)
            UiText(title)
        UiPop() end
    end

    UiButtonImageBox('ui/common/box-outline-6.png', 10,10, 0,0,0, a)
    if UiBlankButton(tglW, tglH) then
        regSetBool(registryPath, not value)
        PlaySound(LoadSound('clickdown.ogg'), GetCameraTransform().pos, 1)
    end

end

ui.colorPicker = {}

function ui.colorPicker.create(title, registryPath, w, h, fontSize, useAlpha)

    w = w or 400
    h = h or 10
    useAlpha = useAlpha or false
    
    UiAlign('left middle')

    -- Text header + color preview
    UiColor(1,1,1, 1)
    UiFont('regular.ttf', fontSize or font_normal)
    local titleW, titleH = UiText(title)
    do UiPush()
        UiAlign('left bottom')
        ui.padding.create(titleW + padW2)
        local r = regGetInt(registryPath..'.r')/255
        local g = regGetInt(registryPath..'.g')/255
        local b = regGetInt(registryPath..'.b')/255
        local a = 1
        if useAlpha then a = regGetInt(registryPath..'.a')/255 end
        UiColor(r, g, b, a)
        UiRect(70, 40)
    UiPop() end
    ui.padding.create(0, fontSize or font_normal)

    -- Red/Green/Blue/Alpha sliders
    ui.slider.create('', registryPath..'.r', 'Red', 0, 255, w, h, fontSize, true, true)
    ui.padding.create(0, fontSize or font_normal)
    ui.slider.create('', registryPath..'.g', 'Green', 0, 255, w, h, fontSize, true, true)
    ui.padding.create(0, fontSize or font_normal)
    ui.slider.create('', registryPath..'.b', 'Blue', 0, 255, w, h, fontSize, true, true)
    if useAlpha then
        ui.padding.create(0, fontSize or font_normal)
        ui.slider.create('', registryPath..'.a', 'Alpha', 0, 255, w, h, fontSize, true, true)
    end

end

ui.button = {}

ui.button.lastWidth = 0
function ui.button.create(text, textColor, borderColor, bgColor, border, w, h, greyed)
    local button = nil
    do UiPush()
        textColor = textColor or {r=0, g=0, b=0, a=1}
        borderColor = borderColor or {r=0, g=0, b=0, a=1}
        bgColor = bgColor or {r=ui.colors.g2[1], g=ui.colors.g2[2], b=ui.colors.g2[3], a=1}
        border = border or 2
        UiFont('bold.ttf', font_normal * 1.5)
        local textW, textH = UiGetTextSize(text)
        local spacing = 2
        w = w or (textW + (2 * spacing) + (2 * border))
        h = h or (textH + (2 * spacing) + (2 * border))
        UiAlign('left middle')
        UiColor(borderColor.r,borderColor.g,borderColor.b,borderColor.a)
        UiRect(w, h)
        ui.padding.create((textW / 2) + spacing + border, 0)
        UiAlign('center middle')
        UiColor(bgColor.r,bgColor.g,bgColor.b,bgColor.a)
        UiRect(w- (border * 2), h - (border * 2))
        UiColor(textColor.r,textColor.g,textColor.b,textColor.a)
        if not greyed then
            button = UiTextButton(text)
        else
            UiText(text)
        end
        if greyed then
            UiColor(0.5,0.5,0.5,0.5)
            UiRect(w, h)
        end
        ui.button.lastWidth = w
    UiPop() end
    return button
end


ui.keyBinding = {}

function ui.keyBinding.create(title, registryPath, inline)

    local value = regGetString(registryPath)

    UiAlign('left middle')

    -- Text header
    UiColor(1,1,1, 1)
    UiFont('regular.ttf', fontSize or font_normal)
    if not inline then
        UiText(title)
        ui.padding.create(0, fontSize or font_normal)
    end

    -- Binding BG
    UiAlign('left top')
    local tglW = w or 160
    local tglH = h or 40

    local editing = (value == "-")
    local text = ""
    if editing then
        text = "Press a key..."
        UiColor(0.6,0.6,0.6, 1)
        local keyPressed = InputLastPressedKey()
        if keyPressed == "" then
            local inside = UiIsMouseInRect(tglW, h or tglH)
            if not inside then
                if InputPressed('lmb') then
                    keyPressed = 'lmb'
                elseif InputPressed('rmb') then
                    keyPressed = 'rmb'
                elseif InputPressed('mmb') then
                    keyPressed = 'mmb'
                end
            end
        end
        if keyPressed ~= "" then
            regSetString(registryPath, keyPressed)
        end
    else
        text = string.upper(value)
        UiColor(0.4,0.4,0.4, 1)
    end

    UiRect(tglW, h or tglH)

    -- Render key
    do UiPush()

        ui.padding.create(tglW/2, tglH/2)
        UiColor(1,1,1, 1)
        UiFont('bold.ttf', font_normal)
        UiAlign('center middle')
        UiText(text)

    UiPop() end

    UiButtonImageBox('ui/common/box-outline-6.png', 10,10, 0,0,0, a)
    if UiBlankButton(tglW, tglH) then
        if editing then
            regSetString(registryPath, "")
        else
            regSetString(registryPath, "-")
        end
        PlaySound(LoadSound('clickdown.ogg'), GetCameraTransform().pos, 1)
    end

    if inline then
        do UiPush()
            ui.padding.create(tglW + padW2, tglH/2)
            UiAlign('left middle')
            UiColor(1,1,1, 1)
            UiFont('regular.ttf', fontSize or font_normal)
            UiText(title)
        UiPop() end
    end

end

ui.lineEdit = {}
ui.lineEdit.editing = {}
ui.lineEdit.cursorPos = {}
ui.lineEdit.exitKeys = {
    ["lmb"] = true,
    ["mmb"] = true,
    ["rmb"] = true,
    ["return"] = true,
    ["esc"] = true,
}
ui.lineEdit.blankKeys = {
    ["shift"] = true,
    ["ctrl"] = true,
    ["alt"] = true,
    ["home"] = true,
    ["pgup"] = true,
    ["pgdown"] = true,
    ["end"] = true,
    ["insert"] = true,
    ["backspace"] = true,
    ["delete"] = true,
    ["leftarrow"] = true,
    ["rightarrow"] = true,
    ["uparrow"] = true,
    ["downarrow"] = true,
}
ui.lineEdit.miscKeys = {
    "lmb", "mmb", "rmb", "`", "-", "=", "[", "]", "\\", ";", "'", ",", ".", "/", "*","+", "~",
    "!", "@", "#", "$","%", "^", "&", "(", ")", "_", "{", "}", "|", ":", '"', "<", ">", "?",
}
ui.lineEdit.holdTimers = {}
ui.lineEdit.textOffsets = {}

function ui.lineEdit.create(title, registryPath, w, h, inline)

    local value = regGetString(registryPath)

    UiAlign('left middle')

    -- Text header
    UiColor(1,1,1, 1)
    UiFont('regular.ttf', fontSize or font_normal)
    if not inline then
        UiText(title)
        ui.padding.create(0, fontSize or font_normal)
    end

    -- Line edit BG
    UiAlign('left top')
    local tglW = w or 400
    local tglH = h or 40

    if ui.lineEdit.cursorPos[registryPath] == nil then
        ui.lineEdit.cursorPos[registryPath] = string.len(value)
    end
    if ui.lineEdit.holdTimers[registryPath] == nil then
        ui.lineEdit.holdTimers[registryPath] = 0
    end
    if ui.lineEdit.textOffsets[registryPath] == nil then
        ui.lineEdit.textOffsets[registryPath] = 0
    end

    local keyHeld = false
    if ui.lineEdit.editing[registryPath] then
        -- Manage key pressed
        UiColor(0.6,0.6,0.6, 1)
        local keyPressed = InputLastPressedKey()
        if keyPressed == "" then
            -- Handle keys not detected by InputLastPressedKey()
            for i=1,#ui.lineEdit.miscKeys do
                local unlistedKey = ui.lineEdit.miscKeys[i]
                if InputPressed(unlistedKey) then
                    keyPressed = unlistedKey
                    break
                end
            end
        end
        -- For key that can be held, use a timer
        local applyKey = false
        if ui.lineEdit.holdTimers[registryPath] > 0 then
            ui.lineEdit.holdTimers[registryPath] = ui.lineEdit.holdTimers[registryPath] - GetTimeStep()
        else
            -- Only set timer if it's the first keypress
            if ui.lineEdit.holdTimers[registryPath] == 0 then
                ui.lineEdit.holdTimers[registryPath] = 0.5
            end
            applyKey = true
        end
        keyHeld = true
        -- Backspace hit, delete current letter
        if InputDown("backspace") then
            if applyKey then
                local before = string.sub(value, 1, -(string.len(value)-ui.lineEdit.cursorPos[registryPath])-2)
                local after = string.sub(value, ui.lineEdit.cursorPos[registryPath]+1, string.len(value))
                --DebugPrint("before: "..before)
                --DebugPrint("after: "..after)
                --DebugPrint("i: "..ui.lineEdit.cursorPos[registryPath])
                value = before .. after
                ui.lineEdit.cursorPos[registryPath] = math.max(0, ui.lineEdit.cursorPos[registryPath] - 1)
            end
        elseif InputDown("delete") then
            if applyKey then
                local before = string.sub(value, 1, -(string.len(value)-ui.lineEdit.cursorPos[registryPath])-1)
                local after = string.sub(value, ui.lineEdit.cursorPos[registryPath]+2, string.len(value))
                --DebugPrint("before: "..before)
                --DebugPrint("after: "..after)
                --DebugPrint("i: "..ui.lineEdit.cursorPos[registryPath])
                value = before .. after
            end
        -- Arrows move cursor
        elseif InputDown("leftarrow") then
            if applyKey then
                ui.lineEdit.cursorPos[registryPath] = math.max(0, ui.lineEdit.cursorPos[registryPath] - 1)
                --DebugPrint("i: "..ui.lineEdit.cursorPos[registryPath])
            end
        elseif InputDown("rightarrow") then
            if applyKey then
                ui.lineEdit.cursorPos[registryPath] = math.min(ui.lineEdit.cursorPos[registryPath] + 1, string.len(value))
                --DebugPrint("i: "..ui.lineEdit.cursorPos[registryPath])
            end
        elseif InputDown("uparrow") then
            if applyKey then
                ui.lineEdit.cursorPos[registryPath] = 0
                --DebugPrint("i: "..ui.lineEdit.cursorPos[registryPath])
            end
        elseif InputDown("downarrow") then
            if applyKey then
                ui.lineEdit.cursorPos[registryPath] = string.len(value)
                --DebugPrint("i: "..ui.lineEdit.cursorPos[registryPath])
            end
        else
            keyHeld = false
        end
        -- Ignore keys that are not a single character
        if ui.lineEdit.blankKeys[keyPressed] then
            keyPressed = ""
        end
        if keyPressed ~= "" then
            -- End editing if requested
            if ui.lineEdit.exitKeys[keyPressed] then
                ui.lineEdit.editing[registryPath] = false
            else
                -- Replace some keys
                if keyPressed == "space" then
                    keyPressed = " "
                elseif keyPressed == "tab" then
                    keyPressed = " "
                end
                -- Handle lowercase letters (default are uppercase)
                if not InputDown("shift") then
                    keyPressed = string.lower(keyPressed)
                end
                local before = string.sub(value, 1, -(string.len(value)-ui.lineEdit.cursorPos[registryPath])-1)
                local after = string.sub(value, ui.lineEdit.cursorPos[registryPath]+1, string.len(value))
                --DebugPrint("before: "..before)
                --DebugPrint("after: "..after)
                --DebugPrint("i: "..ui.lineEdit.cursorPos[registryPath])
                value = before .. keyPressed .. after
                ui.lineEdit.cursorPos[registryPath] = ui.lineEdit.cursorPos[registryPath] + 1
            end
        end
        regSetString(registryPath, value)
    else
        UiColor(0.4,0.4,0.4, 1)
    end
    -- If no key held any more, reset timer
    if not keyHeld then
        ui.lineEdit.holdTimers[registryPath] = 0
    end

    UiRect(tglW, tglH)

    -- Render text
    do UiPush()
        UiWindow(tglW, tglH, true, true)
        local marginH = tglH/4
        ui.padding.create(marginH + ui.lineEdit.textOffsets[registryPath], tglH/2)
        UiColor(1,1,1, 1)
        UiFont('regular.ttf', font_normal)
        UiAlign('left middle')
        UiText(value)

        if ui.lineEdit.editing[registryPath] then
            -- Draw blinking cursor
            local fh = UiFontHeight()
            if GetTime() % 1 < 0.5 or keyHeld then
                UiPush()
                    local textBeforeCursor = string.sub(value, 1, -(string.len(value)-ui.lineEdit.cursorPos[registryPath])-1)
                    -- Replace spaces by a letter of same width to compute text length or they are ignored if they are the beginning or end of string
                    textBeforeCursor = string.gsub(textBeforeCursor, " ", ".")
                    local textW, textH = UiGetTextSize(textBeforeCursor)
                    local cursorOffset = textW - (fh/6)
                    if cursorOffset < 0 then
                        cursorOffset = 0
                    end
                    local dynamicOffset = cursorOffset + ui.lineEdit.textOffsets[registryPath]
                    UiTranslate(cursorOffset, 0)
                    UiColor(1, 1, 1, 1)
                    UiRect(2, fh)
                    -- If cursor is out of bounds on the right, scroll text horizontally to the right
                    local writableArea = tglW - (2*marginH)
                    if dynamicOffset > writableArea then
                        ui.lineEdit.textOffsets[registryPath] = ui.lineEdit.textOffsets[registryPath] - (dynamicOffset - writableArea)
                    end
                    -- If cursor is out of bounds on the left, scroll text horizontally to the left
                    if dynamicOffset < 0 then
                        ui.lineEdit.textOffsets[registryPath] = ui.lineEdit.textOffsets[registryPath] - dynamicOffset
                    end
                UiPop()
            end
        end

    UiPop() end
            
    UiButtonImageBox('ui/common/box-outline-6.png', 10,10, 0,0,0, a)
    if UiBlankButton(tglW, tglH) then
        ui.lineEdit.editing[registryPath] = not ui.lineEdit.editing[registryPath]
        PlaySound(LoadSound('clickdown.ogg'), GetCameraTransform().pos, 1)
    end

    if inline then
        do UiPush()
            ui.padding.create(tglW + padW2, tglH/2)
            UiAlign('left middle')
            UiColor(1,1,1, 1)
            UiFont('regular.ttf', fontSize or font_normal)
            UiText(title)
        UiPop() end
    end

end